/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20141128

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#define YYPREFIX "yy"

#define YYPURE 0

#line 80 "rpld_conf.y"

static char rcsid[]="$Id: rpld_conf.y,v 1.8 2001/11/01 15:23:59 root Exp $";

#include "project.h"

/* state machine stuff*/

typedef enum {START, BLOCK_START, BLOCK_END, ASSERTION, ASSIGNMENT} THING ;
typedef enum {INIT, GLOBALBLOCK, HOSTBLOCK, FILEBLOCK} STATE ;

/*void process_thing(THING thing, char *name, int type, YYSTYPE *pvalue);*/

#line 96 "rpld_conf.y"
#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
typedef union {
		long number;
		char *name;
		char *text;
		char mac_address[6];
		struct partial_mac {
			char mac_address[6];
			int mac_len;
		} pm;
	} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 52 "rpld_conf.tab.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define BLOCK_START 257
#define BLOCK_END 258
#define NAME 259
#define TEXT 260
#define NUMBER 261
#define MACADDR 262
#define MACADDR_PARTIAL 263
#define YYERRCODE 256
typedef short YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,    1,    1,    2,    2,    3,    3,    3,    4,
    4,    4,    4,    4,    4,
};
static const YYINT yylen[] = {                            2,
    2,    3,    3,    2,    2,    1,    1,    2,    3,    1,
    3,    3,    3,    3,    1,
};
static const YYINT yydefred[] = {                         0,
    6,    0,    0,    0,    0,    5,    0,    1,    4,    0,
    7,   15,    0,    0,    2,    0,    3,    0,    8,   11,
   12,   13,   14,    9,
};
static const YYINT yydgoto[] = {                          3,
   12,    5,   13,   14,
};
static const YYINT yysindex[] = {                      -244,
    0, -250, -244,  -51,  -59,    0,  -45,    0,    0,  -60,
    0,    0, -247,  -43,    0, -258,    0,  -42,    0,    0,
    0,    0,    0,    0,
};
static const YYINT yyrindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -41,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,
};
static const YYINT yygindex[] = {                         0,
    6,    0,    0,    7,
};
#define YYTABLESIZE 200
static const YYINT yytable[] = {                         11,
   16,   20,   21,   22,   23,    4,    6,    8,    7,    1,
   17,   10,    1,   15,    2,   19,   24,   10,    0,   18,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    6,    1,    9,   10,
};
static const YYINT yycheck[] = {                         59,
   61,  260,  261,  262,  263,    0,  257,   59,    3,  257,
  258,  259,  257,   59,  259,   59,   59,   59,   -1,   13,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,  257,  258,  259,
};
#define YYFINAL 3
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 263
#define YYUNDFTOKEN 270
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"';'",0,"'='",0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"BLOCK_START","BLOCK_END",
"NAME","TEXT","NUMBER","MACADDR","MACADDR_PARTIAL",0,0,0,0,0,0,"illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : block_list",
"block_list : block ';'",
"block_list : block_list block ';'",
"block : block_start statement_list BLOCK_END",
"block : block_start BLOCK_END",
"block_start : NAME BLOCK_START",
"block_start : BLOCK_START",
"statement_list : ';'",
"statement_list : statement ';'",
"statement_list : statement_list statement ';'",
"statement : NAME",
"statement : NAME '=' TEXT",
"statement : NAME '=' NUMBER",
"statement : NAME '=' MACADDR",
"statement : NAME '=' MACADDR_PARTIAL",
"statement : block",

};
#endif

int      yydebug;
int      yynerrs;

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#define YYINITSTACKSIZE 200

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
/* variables for the parser stack */
static YYSTACKDATA yystack;
#line 134 "rpld_conf.y"

//
// ERROR REPORTING
//

// the lineno variable from our parser
extern int lineno;

// the yytext variable from lex for error reporting
extern char* yytext;

void yyerror(char *s)
{
	fprintf(stderr, "rpld: config line %d: %s near `%s'\n", lineno, s, yytext);
}

//
// CONFIGURATION PROCESSOR
//

// This is the bit that actually does the work

#define strsame(a, b)	(!strcmp((a), (b)))
/*
struct global_parameters
{

} g_params;
*/

struct clientinfo
{
	int have_mac;
	int have_run_addr;
	int have_files;
	// optional
	int have_framesize;
	int have_blocksize;
	int have_pacing;
	int have_nospew;
};

struct clfileinfo
{
	int have_path;
	int have_load_addr;
	// optional
	int have_offset;
	int have_length;
};

extern struct client *clients;

// hideous, we need to cope with a semicolon after this
//#define THROW_ERROR(a)	do { yyerror((a)); exit(1); } while(0)
#define THROW_ERROR(a)	do { fprintf(stderr, "rpld: config line %d: %s near `%s'\n", lineno, (a), name); exit(1); } while(0)

void process_thing(THING thing, char *name, int type, YYSTYPE *pvalue)
{
	static STATE state;
	static struct client *pc;
	static struct clientinfo ci;
	static struct clfile *pcf;
	static struct clfileinfo cfi;

	switch(thing)
	{
	// boot the state machine
	case START:
		state = INIT;
		break;

	//
	// Blocks, which contain related options
	//
	
	// start of a block
	case BLOCK_START:
		// in initial state, move to GLOBALBLOCK or HOSTBLOCK
		if (state == INIT) {
			if (strsame(name, "GLOBAL")) {
				state = GLOBALBLOCK;
				break;
			} else if (strsame(name, "HOST") || strsame(name, "CLIENT")) {
				// construct a new client entity
				pc = (struct client*)malloc(sizeof(struct client));
				bzero(pc, sizeof(struct client));
				// reset info about what options have been set for this client
				bzero(&ci, sizeof(ci));

				pc->blocklen=MY_BLOCK_LEN;
				pc->framelen=MY_FRAME_LEN;
				pc->pacing=MY_PACING;
				
				state = HOSTBLOCK;
				break;
			} else THROW_ERROR("Unknown top-level parameter block");
		}
		// in a HOST block, this must be a FILE
		else if (state == HOSTBLOCK) {
			if (strsame(name, "FILE")) {
				// construct a new file entity
				pcf = (struct clfile*)malloc(sizeof(struct clfile));
				bzero(pcf, sizeof(struct clfile));
				pcf->length=-1;
				// reset info about options set for this file
				bzero(&cfi, sizeof(cfi));
				
				state = FILEBLOCK;
				break;
			} else THROW_ERROR("Only a FILE parameter block can be included in a HOST block");
		}
		// fuck knows
		else
		{
			yyerror("Unknown parameter block");
			exit(1);
		}
		break;

	// end of a block, we should have a bunch of info now
	case BLOCK_END:
		// end GLOBAL block
		if (state == GLOBALBLOCK) {
			// no more global params, at least for the moment
		}
		// end HOST block
		else if (state == HOSTBLOCK) {
			// should have a complete host specification
			if (!ci.have_mac) THROW_ERROR("Must specify an ethernet (MAC) address for host");
			else if (!ci.have_run_addr) THROW_ERROR("Must specify an initial execute address for host");
			else if (!ci.have_files) THROW_ERROR("Must specify at least one file to load for host");

			// OK, should have an entire host spec, so copy it in
			pc->next = clients;
			clients = pc;

			// finished this host spec
			state = INIT;
			break;
		}
		// end FILE block
		else if (state == FILEBLOCK) {
			// should have a complete file specification
			if (!cfi.have_path) THROW_ERROR("Must specify a path for file");
			else if (!cfi.have_load_addr) THROW_ERROR("Must specify a load address for file");

			// have an entire file spec, copy it into the host spec
			pcf->next = pc->files;
			pc->files = pcf;

			ci.have_files = 1;

			// done
			state = HOSTBLOCK;
			break;
		}

	//
	// The various things that go inside blocks
	//
	
	case ASSERTION:
		if (state == GLOBALBLOCK) {
			// no global assertions ATM
			THROW_ERROR("Unknown directive");
		} else if (state == HOSTBLOCK) {
			// no host assertions ATM
			if (strsame(name,"nospew")) {
				if (ci.have_pacing) THROW_ERROR("Directive nospew incompatible with pacing ");
				if (ci.have_nospew) THROW_ERROR("Repeated directive");
				ci.have_nospew=1;
				pc->nospew++;
			} else THROW_ERROR("Unknown directive");
		} else if (state == FILEBLOCK) {
			if (strsame(name,"linux")) {
				if (!cfi.have_path) THROW_ERROR("A path to a valid kernel must precede linux");

				do_linux_kernel(pc,pcf);
				cfi.have_load_addr=1;
				cfi.have_offset=1;
				cfi.have_length=1;
				ci.have_run_addr=1;
			}else{
			THROW_ERROR("Unknown directive");
			}
		} else THROW_ERROR("Unknown directive");
		break;

	case ASSIGNMENT:
		if (state == GLOBALBLOCK) {
			// no global assignments ATM
			THROW_ERROR("Unknown directive");
		} else if (state == HOSTBLOCK) {
			// ethernet address
			if (strsame(name, "ethernet") || strsame(name, "mac")) {
				if (type != MACADDR && type != MACADDR_PARTIAL)
					THROW_ERROR("Directive must be followed by a (partial or complete) ethernet address");
				else if (ci.have_mac) THROW_ERROR("Repeated directive");

				if (type == MACADDR) {
					// set MAC address; this is non-partial, so len = ETH_ALEN
					bcopy(pvalue->mac_address, pc->mac, ETH_ALEN);
					pc->partial_mac_len = ETH_ALEN;
				} else {
					bcopy(pvalue->pm.mac_address, pc->mac, pvalue->pm.mac_len);
					pc->partial_mac_len = pvalue->pm.mac_len;
				}

				ci.have_mac = 1;
			}
			// execute address
			else if (strsame(name, "execute") || strsame(name, "run")) {
				if (type != NUMBER) THROW_ERROR("Directive must be followed by a memory address");
				else if (ci.have_run_addr==2) THROW_ERROR("Repeated directive");

				// set address
				pc->run_addr = pvalue->number;
				ci.have_run_addr = 2;
			}
			else if (strsame(name, "blocksize")) {
				if (type != NUMBER) THROW_ERROR("Directive must be followed by an integer ");
				else if (ci.have_blocksize) THROW_ERROR("Repeated directive");

				// set address
				pc->blocklen = pvalue->number;
				ci.have_blocksize = 1;
			}
			else if (strsame(name, "framesize")) {
				if (type != NUMBER) THROW_ERROR("Directive must be followed by an integer ");
				else if (ci.have_framesize) THROW_ERROR("Repeated directive");

				// set size
				pc->framelen = pvalue->number;
				ci.have_framesize = 1;
			}
			else if (strsame(name,"pacing")) {
				if (type != NUMBER) THROW_ERROR("Directive must be followed by an integer ");
				if (ci.have_nospew) THROW_ERROR("Directive pacing incompatible with nospew ");
				if (ci.have_pacing) THROW_ERROR("Repeated directive");
				pc->pacing = pvalue->number;
				ci.have_pacing =1;
			}
			else THROW_ERROR("Unknown directive");
		} else if (state == FILEBLOCK) {
			// path
			if (strsame(name, "path")) {
				if (type != TEXT) THROW_ERROR("Directive must be followed by a filename");
				else if (cfi.have_path) THROW_ERROR("Repeated directive");

				// set filename
				pcf->path = pvalue->text;
				cfi.have_path = 1;
			}
			// load address
			else if (strsame(name, "load")) {
				if (type != NUMBER) THROW_ERROR("Directive must be followed by a memory address");
				else if (cfi.have_load_addr) THROW_ERROR("Repeated directive");

				// set load address
				pcf->load_addr = pvalue->number;
				cfi.have_load_addr = 1;
			}
			// offset
			else if (strsame(name, "offset")) {
				if (type != NUMBER) THROW_ERROR("Directive must be followed by a memory address");
				else if (cfi.have_offset) THROW_ERROR("Repeated directive");

				// set offset
				pcf->offset = pvalue->number;
				cfi.have_offset = 1;
			}
			// length
			else if (strsame(name, "length")) {
				if (type != NUMBER) THROW_ERROR("Directive must be followed by a memory address");
				else if (cfi.have_length) THROW_ERROR("Repeated directive");

				// set length
				pcf->length = pvalue->number;
				cfi.have_length = 1;
			}
			else THROW_ERROR("Unknown directive");
		}
		break;

		default: THROW_ERROR("Mistake");
	}
	

}
#line 532 "rpld_conf.tab.c"

#if YYDEBUG
#include <stdio.h>		/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = YYLEX) < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            yys = yyname[YYTRANSLATE(yychar)];
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
        {
            goto yyoverflow;
        }
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    YYERROR_CALL("syntax error");

    goto yyerrlab;

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yystack.s_mark]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
                {
                    goto yyoverflow;
                }
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = yyname[YYTRANSLATE(yychar)];
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 3:
#line 115 "rpld_conf.y"
	{ process_thing(BLOCK_END, "", 0, NULL); }
break;
case 4:
#line 116 "rpld_conf.y"
	{ process_thing(BLOCK_END, "", 0, NULL); }
break;
case 5:
#line 118 "rpld_conf.y"
	{ process_thing(BLOCK_START, yystack.l_mark[-1].name, 0, NULL); }
break;
case 6:
#line 119 "rpld_conf.y"
	{ process_thing(BLOCK_START, "", 0, NULL); }
break;
case 10:
#line 126 "rpld_conf.y"
	{ process_thing(ASSERTION, yystack.l_mark[0].name, 0, NULL); }
break;
case 11:
#line 127 "rpld_conf.y"
	{ process_thing(ASSIGNMENT, yystack.l_mark[-2].name, TEXT, &yystack.l_mark[0]); }
break;
case 12:
#line 128 "rpld_conf.y"
	{ process_thing(ASSIGNMENT, yystack.l_mark[-2].name, NUMBER, &yystack.l_mark[0]); }
break;
case 13:
#line 129 "rpld_conf.y"
	{ process_thing(ASSIGNMENT, yystack.l_mark[-2].name, MACADDR, &yystack.l_mark[0]); }
break;
case 14:
#line 130 "rpld_conf.y"
	{ process_thing(ASSIGNMENT, yystack.l_mark[-2].name, MACADDR_PARTIAL, &yystack.l_mark[0]); }
break;
#line 770 "rpld_conf.tab.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            if ((yychar = YYLEX) < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                yys = yyname[YYTRANSLATE(yychar)];
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
    {
        goto yyoverflow;
    }
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    YYERROR_CALL("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
